if(!dojo._hasResource["com.ibm.mm.builder.builderCompatibleProxy"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.builderCompatibleProxy"] = true;
dojo.provide("com.ibm.mm.builder.builderCompatibleProxy");

dojo.provide("com.ibm.mm.builder.widgetAttributes");
dojo.provide("com.ibm.mm.builder.widget.baseWidget");
dojo.provide("com.ibm.mm.builder.eventUtil");
dojo.provide("com.ibm.mm.builder.mmHtmlUtils");
dojo.provide("com.ibm.mm.builder.dataViewerUtil");

dojo.declare("com.ibm.mm.builder.widgetAttributes",null,{
	deserializeAttributes:function() {
	}
});

dojo.declare("com.ibm.mm.builder.widget.baseWidget", null, {
});


dojo.declare("com.ibm.mm.builder.eventUtil",null,{

	publishEvent: function(id,eventName,payload) {
		com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(id,eventName,payload);
	},
	
	publishWireEvent: function(id,eventName,type,payload) {
		com.ibm.mashups.services.ServiceManager.getService("eventService").publishWire(id,eventName,payload);
	}
	
});

dojo.declare("com.ibm.mm.builder.mmHtmlUtils", null, {
	
	getElementsByClass: function(
		/* string */classStr, 
		/* HTMLElement? */parent, 
		/* string? */nodeType, 
		/* integer? */classMatchType, 
		/* boolean? */useNonXpath
	){
		
		useNonXpath = false;
		var _document = dojo.doc;
		parent = dojo.byId(parent) || _document;
		var classes = classStr.split(/\s+/g);
		var nodes = [];
		if (classMatchType !== 1 && classMatchType !== 2) {
			classMatchType = 0;  // make it enum
		}
		var reClass = new RegExp("(\\s|^)((" + classes.join(")|(") + "))(\\s|$)");
		var srtLength = classes.join(" ").length;
		var candidateNodes = [];
		
		if(!useNonXpath && _document.evaluate) { // supports dom 3 xpath
		
			var xpath = ".//" + (nodeType || "*") + "[contains(";
			if(classMatchType != this.classMatchType.ContainsAny){
				xpath += "concat(' ',@class,' '), ' " +
				classes.join(" ') and contains(concat(' ',@class,' '), ' ") +
				" ')";
				if (classMatchType == 2) {
					xpath += " and string-length(@class)="+srtLength+"]";
				}else{
					xpath += "]";
				}
			}else{
				xpath += "concat(' ',@class,' '), ' " +
				classes.join(" ') or contains(concat(' ',@class,' '), ' ") +
				" ')]";
			}
			var xpathResult = _document.evaluate(xpath, parent, null, XPathResult.ANY_TYPE, null);
			var result = xpathResult.iterateNext();
			while(result){
				try{
					candidateNodes.push(result);
					result = xpathResult.iterateNext();
				}catch(e){ break; }
			}
			return candidateNodes;	//	NodeList
		}else{
			if(!nodeType){
				nodeType = "*";
			}
			candidateNodes = parent.getElementsByTagName(nodeType);
			var node, i = 0;
			outer:
			while(node = candidateNodes[i++]){ //JSLINT-IGNORE: deprecated method for mashups 1.0
				var nodeClasses = this.getClasses(node);
				if(nodeClasses.length === 0){ continue outer; }
				var matches = 0;
				for(var j = 0; j < nodeClasses.length; j++){
					if(reClass.test(nodeClasses[j])){
						if(classMatchType == this.classMatchType.ContainsAny){
							nodes.push(node);
							continue outer;
						}else{
							matches++;
						}
					}else{
						if(classMatchType == this.classMatchType.IsOnly){
							continue outer;
						}
					}
				}
		
				if(matches == classes.length){
					if(	(classMatchType == this.classMatchType.IsOnly)&&
						(matches == nodeClasses.length)){
						nodes.push(node);
					}else if(classMatchType == this.classMatchType.ContainsAll){
						nodes.push(node);
					}
				}
			}
			return nodes;	//	NodeList
		}
	}
});

com.ibm.mm.builder.htmlUtil = new com.ibm.mm.builder.mmHtmlUtils();


dojo.provide("com.ibm.mm.builder.dataViewerUtil");

com.ibm.mm.builder.dataViewerUtil.encodeCSVCell = function(cell){
	return com.ibm.mashups.data.Util.encodeCSVCell(cell);
};

com.ibm.mm.builder.dataViewerUtil.JSONObject2CSV = function(json){
	return com.ibm.mashups.data.Util.JSONObject2CSV(json);
};

com.ibm.mm.builder.dnd.MumManager = dojo.dnd.manager;
com.ibm.mm.builder.Topics.DnD_Drop = "/dnd/drop";

}
