if(!dojo._hasResource["com.ibm.mm.builder.dialog.NewPageDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.NewPageDialog"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.NewPageDialog");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

/**
 * This class will create a dialog for user to change widget instance title and icon
 */
dojo.declare("com.ibm.mm.builder.dialog.NewPageDialog", [dijit._Widget, dijit._Templated], {
	
	templateString: 
		'<div>'+
			'<div class="mmDialogTopArea">'+
				'<img src="'+builderConfig.builderPath+'/images/widget.png" alt="">'+
				'<span dojoAttachPoint="renamePrompt" class="mmDialogTopAreaTitle"></span>'+
			'</div>'+
			'<div style="margin:20px 10px 30px 20px">'+
				'<div class="pageProperty_item">'+
					'<input dojoAttachPoint="pageName" type="text" class="pageProperty_item_content"></input>'+
				'</div>'+
			'</div>'+
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
		'</div>',
		
	widgetsInTemplate: true,

	postCreate: function() {
		this.editorTitleDiv = document.createElement("div");
		document.body.appendChild(this.editorTitleDiv);
		this.editorTitleDiv.appendChild(this.domNode);
		this.renamePrompt.innerHTML = "Please input your page name:";
		//this.cancelBtn.innerHTML=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL;
		//this.saveBtn.value=com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE;
		
		this.dialog = new com.ibm.mm.builder.widget.WidgetEditDialog({
			belongId: this.iwidgetId,
			containerBackgroundColor: "white",
			nodeWidth: "430px"
		}, this.editorTitleDiv);
		
		this._pageUtil = com.ibm.mm.builder.utils.pageUtil;
	},
	
	child: false,
	
	/**
	 * show the page property dialog
	 */
	show: function() {
		this.dialog.show();
	},

	/**
	 * hide the page property dialog
	 */		
	hide: function() {
		this.dialog.hide();
	},
		
	save: function() {
		//invoke api to do this
		var name = this.pageName.value;
		if (!this._pageUtil.validatePageName(name)) { return; }
		name = dojo.trim(name);
		if (this.child) {
			this._pageUtil.createPage(name, this._pageUtil.getCurrentPageId());
		} else {
			this._pageUtil.createPage(name);
		}
		this.hide();
	}
});

}
