if(!dojo._hasResource["com.ibm.mm.builder.widget.WidgetEditBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.WidgetEditBar"] = true;
dojo.provide("com.ibm.mm.builder.widget.WidgetEditBar");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("com.ibm.mm.builder.widget.WidgetEditBar",[dijit._Widget, dijit._Templated],{	

	templateString:
		'<div id="${widgetId}_dragHandler_editbar" style="display:none" class="editBar" '+
			'dojoAttachEvent="onmouseover: show">'+
			'<div id="${widgetId}_dragHandler" class="dojoDndHandle borderinHM">'+
				'<div class="${widgetDragHandlerLeft}"></div>'+
				'<div class="${widgetDragHandlerRight}"></div>'+
				'<div class="widgetDragHandlerMiddle">'+
					'<img class="widgetIconStyle">'+
					'<span class="widgetTitleShadow">${title}</span>'+
					'<span class="widgetTitle">${title}</span>'+
					'<img src="${wireIconUrl}" class="widgetInteraction" '+
						'dojoAttachEvent="onclick:_onWireIconClick,onmousedown:_onMouseDown,onkeypress:_wireIconOnKeypress" '+
						'border=0 title="${I_SKIN_WIRE_ICON_TITLE}" alt="${I_SKIN_WIRE_ICON_TITLE}" tabIndex="0"/>'+
					'<img id="${widgetId}_menu" src="${editIconUrl}" class="widgetContext" '+
						'dojoAttachEvent="onclick:_onEditIconClick,onmousedown:_onMouseDown,onkeypress:_editIconOnKeypress" '+
						'border=0 title="${I_SKIN_EDIT_ICON_TITLE}" alt="${I_SKIN_EDIT_ICON_TITLE}" tabIndex="0"/>'+	
				'</div>'+
			'</div>'+
			'<div class="widgetDragHandlerBG"></div>'+
			'<div class="widgetDragHandlerCorner"></div>'+
			'<div class="editBarRightTopCornerShadow"></div>'+	
			'<div class="editBarCornerShadow"></div>'+
		'</div>',
		
	I_SKIN_WIRE_ICON_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_WIRE_ICON_TITLE, 
	I_SKIN_EDIT_ICON_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_SKIN_EDIT_ICON_TITLE,
	
	wireIconUrl: builderConfig.builderPath + (builderConfig.isBidi ? "/images/d_wiring_icon_rtl.png" :
		"/images/d_wiring_icon.png"),
	
	editIconUrl: builderConfig.builderPath + (builderConfig.isBidi ? "/images/context_menu_rtl.png" :
		"/images/context_menu.png"),
	
	widgetDragHandlerLeft: builderConfig.isBidi ? "widgetDragHandlerLeftRtl" : "widgetDragHandlerLeft",
	widgetDragHandlerRight: builderConfig.isBidi ? "widgetDragHandlerRightRtl" : "widgetDragHandlerRight",
	
	iconUrl: null,
	title: "",
	widgetId: null,
	
	_wireIconOnKeypress: function(e){
		if (e.keyCode == dojo.keys.ENTER) {
			this._onWireIconClick();
		}
	},
	
	_editIconOnKeypress: function(e){
		if (e.keyCode == dojo.keys.ENTER) {
			com.ibm.mm.builder.skinHelper.createMenu(e, this.widgetId + "_menu", this.widgetId, false);
		}
	},
	
	_onMouseDown: function(evt){
		dojo.stopEvent(evt);
	},
	
	_onEditIconClick: function(evt){
		com.ibm.mm.builder.skinHelper.createMenu(evt, this.widgetId+"_menu", this.widgetId, false);
	},
	
	_onWireIconClick: function(evt){
		if (!this._isWidgetLoaded()) {
			return;
		}
		this.hide();
		com.ibm.mm.builder.skinHelper.launchWiring(this.widgetId);
	},
	
	_isWidgetLoaded: function(){
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.widgetId);
		return widgetModel && widgetModel.loaded;
	},
	
	onKeyPress: function(evt){
		if (evt.keyCode == dojo.keys.ENTER || evt.charCode == dojo.keys.SPACE) {
//			dojo.stopEvent(evt);
			this.show();
		}
	},
	
	keep: function(){
		clearTimeout(this.hideTimer);
	},
	
	show: function(evt){
		if(com.ibm.mm.builder.utils.pageUtil.getCurrentPageMode() != "edit"){
			return;
		}
		clearTimeout(this.showTimer);
		clearTimeout(this.hideTimer);
		this.showTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "";
			}
		}), 100);
	},
	
	hide: function(evt){
		if (com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu && com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow) {
			return;
		}
			
		clearTimeout(this.hideTimer);
		clearTimeout(this.showTimer);
		this.hideTimer = setTimeout(dojo.hitch(this, function(){
			if (this.domNode) {
				this.domNode.style.display = "none";
			}
			if (builderConfig.isBidi && dojo.isIE===6) {                	
		    	dojo.removeClass(this.widgetId + com.ibm.mm.builder.constant.widgetBody, "widgetBodyEdit");
		    	var _title = dojo.byId(this.widgetId + "_title");
		    	if (_title) {
					dojo.removeClass(_title, "widgetTitleEdit");
				}
		    	if (dojo.hasClass(this.widgetId + com.ibm.mm.builder.constant.widgetContent, "rtlOverride_IE_paddingTop_0px")) {
		    		dojo.byId(this.widgetId + com.ibm.mm.builder.constant.widgetContent).style.paddingTop = "0px";
		    	}			    	
	        }
		}), 100);
	}
});

}
