dojo.provide("com.ibm.mm.builder.systemwidget.ContentSetMenu");
dojo.require("com.ibm.pb.widgets.ContentMenu");
dojo.require("dijit.MenuItem");
dojo.require("dijit.PopupMenuItem");
dojo.require("dijit.MenuSeparator");
dojo.require("com.ibm.pb.iwidget.iWidgetBase");
dojo.declare("com.ibm.mm.builder.systemwidget.ContentSetMenu",[com.ibm.pb.iwidget.iWidgetBase],{openEvent:"",closeEvent:"",menuCSSClass:"",anchorCSSClass:"",menu:null,contextMenuID:"",resourceType:"",updated:false,beforeOpen:null,constructor:function(){
this._menuConnections=[];
this._submenus=[];
},onLoad:function(){
var _1="onLoad",_2=this.LOGGER;
_2.entering(_1,arguments);
this.inherited(arguments);
dojo.mixin(this,this.getItemSetValues(["contextMenuID","resourceType","openEvent","closeEvent","menuCSSClass","anchorCSSClass","beforeOpen"]));
this.id=this.iContext.widgetId;
if(this.openEvent){
_2.trace(_1,"Subscribing to open event ${0}",[this.openEvent]);
this.evtSvc.subscribeEvent(this.openEvent,this,this.open,null,this.id);
}
if(this.closeEvent){
_2.trace(_1,"Subscribing to close event ${0}",[this.closeEvent]);
this.evtSvc.subscribeEvent(this.closeEvent,this,this.close,null,this.id);
}
com.ibm.mashups.builder.model.Factory.getContextMenuModel().registerListener(this.contextMenuID,this,"_menuChanged");
_2.exiting(_1,arguments);
},_menuChanged:function(){
this.updated=true;
},open:function(_3){
var _4="open",_5=this.LOGGER;
_5.entering(_4,arguments);
try{
if(!this.menu||this.updated||this.menu.resourceID!=_3.resourceId){
this._initMenu();
if(this.beforeOpen){
try{
dojo.eval(this.beforeOpen+"()");
}
catch(ex){
console.log("Error when calling beforeOpen: ",ex);
}
}
this.menu.initContents(_3.resourceId);
}
var me=this,_6=_3.orientation;
if(!_6){
_6=this.menu.isLeftToRight()?{"BL":"TL","TL":"BL","BR":"TR","TR":"BR"}:{"BR":"TR","TR":"BR","BL":"TL","TL":"BL"};
}
var _7=this.menu;
var _8,_9;
try{
_8=_3.domNode||dijit.getFocus(_7);
_9=function(){
if(_7.refocus){
dijit.focus(_8);
}
me.close();
};
}
catch(ex){
console.log("error when getFocus");
}
_5.trace(_4,"Popping up menu ${0} around ${1} using orientation ${2}",[this.menu,_3.domNode,_6]);
if(_3.domNode&&this.anchorCSSClass){
dojo.addClass(_3.domNode,this.anchorCSSClass);
}
dijit.popup.open({popup:this.menu,orient:_6,around:_3.domNode,onExecute:_9,onCancel:_9,onClose:function(){
if(_3.domNode&&me.anchorCSSClass){
dojo.removeClass(_3.domNode,me.anchorCSSClass);
}
}});
if(this.menu.focusedChild){
if(this.menu.focusedChild._destroyed){
this.menu.focusedChild=null;
}
}
this.menu.focus();
this.updated=false;
}
catch(err){
_5.severe(_4,"Error opening menu ${0} ${1}",[this,err]);
throw err;
}
_5.exiting(_4,arguments);
},close:function(_a){
var _b="close",_c=this.LOGGER;
_c.entering(_b,arguments);
if(this.menu.close){
this.menu.close();
}else{
dijit.popup.close(this.menu);
}
_c.exiting(_b,arguments);
},_initMenu:function(_d){
var _e="_initMenu",_f=this.LOGGER,me=this;
_f.entering(_e,arguments);
while(this._menuConnections.length>0){
dojo.disconnect(this._menuConnections.shift());
}
if(this.menu){
try{
this.menu.destroyRecursive();
}
catch(e){
}
}
var _10={contextMenuID:this.contextMenuID,resourceType:this.resourceType,leftClickToOpen:true,offset_y:9,internalRefresh:false};
if(this.menuCSSClass){
_10["class"]=this.menuCSSClass;
_10.getInheritableParams=function(){
var _11=this.inherited("getInheritableParams",arguments);
_11["class"]=me.menuCSSClass;
return _11;
};
}
this.menu=new com.ibm.pb.widgets.ContentMenu(_10);
this._menuConnections.push(dojo.connect(this.menu,"onBlur",this,this.close));
this.menu.startup();
if(document.body.dir=="rtl"&&dojo.isSafari&&navigator.userAgent.indexOf("iPad")!=-1){
dojo.removeClass(this.menu.domNode,"dijitMenuTable");
}
_f.exiting(_e,arguments);
},onUnload:function(){
if(this.menu){
this.menu.destroyRecursive();
delete this.menu;
}
}});

